@import "variables";

@mixin scroll-touch-fix() {
  -webkit-overflow-scrolling: touch;
  overscroll-behavior: contain;
}

@mixin responsive-property($property, $values, $flags: null) {
  #{$property}: nth(map-values($values), 1);

  @each $step, $val in $values {
    @media only screen and (min-width: $step) {
      #{$property}: toRem($val, $base-fontsize);
    }
  }
}

@function fetch($map, $keys...) {
  $value: $map;
  @each $key in $keys {
    $value: map-get($value, $key);
  }
  @return $value;
}

@function merge($parent-map, $child-map) {
  $result: $parent-map;
  @each $key, $value in $child-map {
    @if (not map-has-key($result, $key)) or
      (type-of(map-get($result, $key)) != type-of($value)) or
      (not (type-of(map-get($result, $key)) == map and type-of($value) == map)) {
      $result: merge(
          $result,
          (
            $key: $value
          )
      );
    } @else {
      $result: merge(
          $result,
          (
            $key: merge(map-get($result, $key), $value)
          )
      );
    }
  }
  @return $result;
}

@function strip-unit($num) {
  @return $num / ($num * 0 + 1);
}

@function is($name) {
  @return fetch($ui, $name);
}

@function query-below($mq) {
  @return $mq - 1px;
}

@mixin query-below($mq) {
  @media (max-width: #{query-below($mq)}) {
    @content;
  }
}

@mixin query-above($mq) {
  @media (min-width: #{$mq}) {
    @content;
  }
}

@mixin query-between($mq-from, $mq-to) {
  @include query-above($mq-from) {
    @include query-below($mq-to) {
      @content;
    }
  }
}

@function toRem($size, $base) {
  @return $size / $base * 1rem;
}
